<template>
  <div>
    <back-box>
      <template slot="title">
        <span>备题组卷</span>
      </template>
      <template slot="btns">
        <el-tooltip
          v-if="!code && gdClass"
          effect="dark"
          content="已归档试卷"
          placement="bottom"
        >
          <el-button
            type="primary"
            icon="fa fa-archive"
            size="mini"
            plain
            circle
            @click="toArchiving"
          ></el-button>
        </el-tooltip>
        <el-button
          type="primary"
          size="mini"
          icon="el-icon-plus"
          plain
          @click="toAdd({})"
        >
          添加答题卡</el-button
        >
      </template>
    </back-box>

    <div class="answer-header">
      <div class="sel-box">
        <el-select
          class="sel"
          v-model="query.classId"
          placeholder="选择班级"
          @change="changClazz"
        >
          <el-option
            v-for="item in classList"
            :key="item.value"
            :label="item.label"
            :value="item.value"
          >
          </el-option>
        </el-select>
        <el-select
          class="sel"
          v-model="query.subjectName"
          placeholder="选择科目"
          @change="_QueryData()"
        >
          <el-option
            v-for="item in subjectList"
            :key="item.value"
            :label="item.label"
            :value="item.value"
          >
          </el-option>
        </el-select>
        <el-select
          class="sel"
          v-model="query.tagId"
          placeholder="选择类型"
          @change="_QueryData()"
        >
          <el-option
            v-for="item in typeList"
            :key="item.label"
            :label="item.label"
            :value="item.value"
            >{{ item.label }}
          </el-option>
        </el-select>
        <el-input
          placeholder="试卷名称"
          v-model="query.title"
          class="input-with-select"
          @keyup.enter.native="_QueryData(true)"
        >
          <el-button
            slot="append"
            icon="el-icon-search"
            @click="_QueryData(true)"
          ></el-button>
        </el-input>
      </div>
    </div>
    <p class="tips" v-show="archivedTotal">
      <span>回收站内已有{{ archivedTotal }}份答题卡,</span>
      <router-link to="/examinationPaperRecycle">点击查看&gt;&gt;</router-link>
    </p>
    <ul class="content" v-if="tableData && tableData.length">
      <li class="item" v-for="item in tableData" :key="item.id">
        <div class="pic-box">
          <p class="i-box"><i class="fa fa-map-o"></i></p>
          <p class="ids">{{ item.id }}</p>
        </div>
        <div class="info">
          <p class="title">
            {{ item.title }}
            <span class="label" v-if="!!item.tag">{{ item.tag }}</span>
          </p>
          <p class="num">
            总题数：{{ item.questionNum }}
            <em class="s-line">|</em>
            预计时长：{{ item.examsDuration }}
            <em class="s-line">|</em>
            <template v-if="role != 'ROLE_PERSONAL'">
              授课端同步：
              <span
                class="clazz"
                v-for="(clazzChild, indexs) in item.classList"
                :key="clazzChild.classId"
                :class="clazzChild.keepStatus == 1 ? 'active' : ''"
                >{{
                  `${clazzChild.className}${
                    indexs != item.classList.length - 1 ? "、" : ""
                  }`
                }}
                <i v-if="clazzChild.keepStatus == 1" class="el-icon-success"></i
              ></span>
              <el-tooltip
                effect="dark"
                content="刷新同步状态"
                placement="right"
              >
                <i
                  class="icon-refresh el-icon-refresh"
                  @click="refreshStic"
                ></i>
              </el-tooltip>
            </template>
          </p>
          <p class="person">
            {{ item.realName }}<em class="s-line">|</em
            ><span class="date">{{ item.modifiedTime }}</span>
          </p>
        </div>
        <div class="btn-box">
          <el-tooltip effect="dark" content="修改答案" placement="bottom">
            <el-button
              class="edit"
              type="primary"
              size="mini"
              circle
              icon="el-icon-edit"
              @click="toEdit(item)"
            ></el-button>
          </el-tooltip>
          <el-dropdown
            trigger="click"
            @command="handleDropdownClick($event, item)"
          >
            <el-button
              type="info"
              size="mini"
              circle
              icon="el-icon-more"
            ></el-button>
            <el-dropdown-menu slot="dropdown">
              <el-dropdown-item
                :command="1"
                v-if="userName == item.realName && role != 'ROLE_PERSONAL'"
                >修改分享范围</el-dropdown-item
              >
              <el-dropdown-item :command="2">复制</el-dropdown-item>
              <el-dropdown-item :command="3">放入回收站</el-dropdown-item>
            </el-dropdown-menu>
          </el-dropdown>
        </div>
      </li>
    </ul>
    <div class="pagination-box">
      <el-pagination
        small=""
        layout="total,prev, pager, next"
        :hide-on-single-page="true"
        :total="total"
        @current-change="changePage"
        :current-page="page"
        :page-size="size"
      >
      </el-pagination>
    </div>
    <el-empty
      v-if="!loading && tableData.length == 0"
      content="没有更多数据"
      :image-size="100"
    ></el-empty>
    <el-dialog :close-on-click-modal="false" title="选择分享范围" :visible.sync="dialogVisible" width="400">
      <el-form :model="shareForm" :rules="shareRulesForm" label-width="160px">
        <el-form-item prop="share" label="分享范围：">
          <el-radio-group v-model="shareForm.sharingType">
            <el-radio :label="0">任课班级分享</el-radio>
            <el-radio :label="1">全年级分享</el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="saveShare">确 定</el-button>
        <el-button @click="dialogVisible = false">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
export default {
  name: "examinationPaper",
  data() {
    return {
      code: "",
      gdClass: 0, //已归档班级数量
      loading: false,
      userName: "",
      dialogVisible: false,
      query: {
        classId: "",
        subjectName: "",
        tagId: "",
        title: "",
      },
      classList: [],
      subjectList: [],
      typeList: [],
      archivedTotal: 0, //已归档答题卡数量
      tableData: null,
      shareForm: {
        id: "",
        sharingType: 0, //0-任课班级/1-全年级
      },
      shareRulesForm: {
        sharingType: [
          { required: true, message: "选择分享范围", trigger: "blur" },
        ],
      },
      total: 0,
      page: 1,
      size: 20,
    };
  },
  async created() {
    this.code = localStorage.getItem("csCode") || "";
    this.role =
      this.$store.getters.info.showRole ||
      this.$store.getters.info.permissions[0].role;
    this.userName = this.$store.getters.info.name || "";
    this._QueryClassList2()
    await this._QueryClassList();
    if (!this.query.classId) {
      return;
    }
    await this._QuerySubjectList();
    this._QueryData();
    this._QueryTypeList();
  },
  methods: {
    refreshStic() {
      setTimeout(function () {
        window.location.reload();
      }, 500);
    },
    toArchiving() {
      this.$router.push({
        path: "/examinationPaperArchiving",
      });
    },
    toAdd(query) {
      if (!this.query.classId) {
        this.$message.warning("没有任课班级，请先设置。");
        return;
      }
      let routerItem = {
        path: "/examinationPaperAdd",
      };
      query ? (routerItem["query"] = { ...query }) : "";
      this.$router.push(routerItem);
    },
    toEdit(item) {
      this.$router.push({
        path: "/examinationPaperEdit",
        query: {
          paperId: item.id,
        },
      });
    },
    handleDropdownClick(value, item) {
      //更多
      const that = this;
      switch (value) {
        case 1:
          //修改分享范围
          that.shareForm.id = item.id;
          that.shareForm.sharingType = item.sharingType;
          that.dialogVisible = true;
          break;
        case 2:
          //复制
          that.toAdd({ type: 2, paperId: item.id });
          break;
        case 3:
          //归档
          that.recovery(item);
          break;
      }
    },
    changePage(page) {
      this.page = page;
      this._QueryData(this.query.title);
    },
    async saveShare() {
      //修改分享范围
      const { data, status, info } = await this.$request.modifyPaper({
        paperId: this.shareForm.id,
        sharingType: this.shareForm.sharingType,
      });
      if (status === 0) {
        this.shareForm.id = "";
        this.shareForm.sharingType = 1;
        this.dialogVisible = false;
        this.$message.success(info);
        this._QueryData(this.query.title == "");
      } else {
        this.$message.error(info);
      }
    },
    async recovery(item) {
      //归档
      let modifyPaper =
        this.role == "ROLE_PERSONAL"
          ? this.$request.pModifyPaper
          : this.$request.modifyPaper;
      const { data, status, info } = await modifyPaper({
        paperId: item.id,
        status: 2,
      });
      if (status === 0) {
        let type = this.query.title ? 1 : 0;
        this.page = 1;
        this._QueryData(type);
      } else {
        this.$message.error(info);
      }
    },
    //切换班级
    async changClazz() {
      await this._QuerySubjectList();
      this._QueryData(false);
    },
    // 查找答题卡类型
    async _QueryTypeList() {
      if (!this.query.classId) return;
      let fetchTypeNames =
        this.role == "ROLE_PERSONAL"
          ? this.$request.pPaperTagList
          : this.$request.fetchTypeNames;

      const { data, status, info } = await fetchTypeNames({
        classId: this.query.classId,
        type: 0,
      });
      if (status === 0) {
        this.typeList =
          data.list.map((item) => {
            return {
              value: item.tagId,
              label: item.tag,
            };
          }) || [];
        this.typeList.unshift({
          value: "",
          label: "请选择标签",
        });
      } else {
        this.$message.error(info);
      }
    },
    // 查找班级
    async _QueryClassList2() {
      this.loading = true;
      let fetchClassList =
        this.role == "ROLE_PERSONAL"
          ? this.$request.pClassList
          : this.$request.fetchClassList;

      const { data, status, info } = await fetchClassList({ status: 1 });
      if (status === 0) {
        this.gdClass = data?.list?.length || 0;
      } else {
        this.$message.error(info);
      }
    },
    // 查找班级
    async _QueryClassList() {
      this.loading = true;
      let fetchClassList =
        this.role == "ROLE_PERSONAL"
          ? this.$request.pClassList
          : this.$request.fetchClassList;

      const { data, status, info } = await fetchClassList();
      if (status === 0) {
        if (!!data.list) {
          this.classList =
            data.list?.map((item) => {
              return {
                value: this.role == "ROLE_PERSONAL" ? item.id : item.classId,
                label: item.className,
              };
            }) || [];
          this.query.classId = this.classList[0]?.value;
        }
      } else {
        this.$message.error(info);
      }
    },
    // 查找科目
    async _QuerySubjectList() {
      if (!this.query.classId) return;
      let fetchSubjectList =
        this.role == "ROLE_PERSONAL"
          ? this.$request.pSubjectList
          : this.$request.fetchSubjectList;

      const { data, status, info } = await fetchSubjectList({
        classId: this.query.classId,
      });
      if (status === 0) {
        this.subjectList =
          data.subjectNames?.map((item) => {
            return {
              value: item,
              label: item,
            };
          }) || [];
        this.query.subjectName = this.subjectList[0]?.value;
      } else {
        this.$message.error(info);
      }
    },
    async _QueryData(type) {
      if (!this.query.classId) return;
      this.loading = true;
      //获取答题卡列表
      let query = {};
      if (!type) {
        this.query.title = "";
        query = { ...this.query };
      } else {
        query = { title: this.query.title };
        this.query.tagId = "";
        // this.query.subjectName = "";
      }
      query.classId = this.query.classId;
      query.subjectName = this.query.subjectName;
      for (let key in query) {
        if (!query[key]) {
          query[key] = null;
        }
      }
      if (!query.classId) {
        this.total = 0;
        this.tableData = [];
        this.loading = false;
        return;
      }
      this.loading = true;
      let fetchPaperList =
        this.role == "ROLE_PERSONAL"
          ? this.$request.pPaperList
          : this.$request.fetchPaperList;

      const { data, status, info } = await fetchPaperList({
        ...query,
        status: 1,
        page: this.page,
        size: this.size,
      });
      this.loading = false;
      if (status === 0) {
        this.archivedTotal = data.archivedTotal;
        this.total = data.total;
        this.tableData = (data.list && [...data.list]) || [];
      } else {
        this.$message.error(info);
      }
    },
  },
};
</script>

<style scoped lang="scss">
.tips {
  display: flex;
  padding-left: 30px;
  line-height: 16px;
  font-size: 14px;
  color: #999;
  margin-bottom: 10px;
}
.content {
  margin: 0 20px;
  background: #f8f8f8;
  padding: 12px;
  border-radius: 20px;
  .item {
    display: flex;
    align-items: center;
    width: 100%;
    overflow: hidden;
    box-sizing: border-box;
    padding: 12px;
    border-radius: 20px;
    background: #fff;
    margin-bottom: 12px;
    &:last-of-type {
      margin-bottom: 0;
    }
    .pic-box {
      width: 80px;
      height: 80px;
      border-radius: 10px;
      margin-right: 10px;
      flex-shrink: 0;
      background: #667ffd;
      text-align: center;
      color: #fff;
      font-weight: 500;
      .i-box {
        padding-top: 10px;
        font-size: 32px;
        margin-bottom: 3px;
      }
    }
    .info {
      min-height: 80px;
      flex: 1;
      overflow: hidden;
      display: flex;
      flex-direction: column;
      justify-content: space-between;
      .s-line {
        padding: 0 5px;
        color: #e2e2e2;
      }
      .title {
        font-size: 16px;
        color: #222;
        font-weight: 500;
        .label {
          display: inline-block;
          font-size: 12px;
          color: #2e9afe;
          line-height: 16px;
          padding: 0 10px;
          border: 1px solid #2e9afe;
          border-radius: 10px;
          transform: translateY(-2px);
        }
      }
      .person {
        color: #666;
      }
    }
    .clazz {
      font-size: 14px;
      font-weight: 500;
      position: relative;
      position: relative;
      &.active {
        color: #667ffd;
      }
      .el-icon-success {
        position: absolute;
        right: 0;
        top: -5px;
        color: #667ffd;
      }
      &:last-of-type {
        .el-icon-success {
          right: -18px;
        }
      }
    }
    .btn-box {
      flex-shrink: 0;
      .edit {
        margin-right: 12px;
      }
    }
    .icon-refresh {
      margin-left: 20px;
      cursor: pointer;
      &:hover {
        color: #2e9afe;
      }
    }
  }
}
.answer-header {
  .sel-box {
    .sel {
      min-width: 160px;
    }
    :deep(.el-cascader__tags) {
      flex-wrap: nowrap;
    }
  }
}
.dialog-footer {
  text-align: center;
  :deep(.el-button) {
    border-radius: 20px;
    padding: 8px 20px 7px;
    margin: 0 12px;
  }
}
</style>